# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class ArchiveType(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'object',
        'creation': 'ChangeInfo',
        'last_update': 'ChangeInfo',
        'master_archive_type': 'bool',
        'res_id': 'str',
        'type_name': 'str'
    }

    attribute_map = {
        'links': '_links',
        'creation': 'creation',
        'last_update': 'lastUpdate',
        'master_archive_type': 'masterArchiveType',
        'res_id': 'resId',
        'type_name': 'typeName'
    }

    def __init__(self, links=None, creation=None, last_update=None, master_archive_type=None, res_id=None, type_name=None, local_vars_configuration=None):  # noqa: E501
        """ArchiveType - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._creation = None
        self._last_update = None
        self._master_archive_type = None
        self._res_id = None
        self._type_name = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if creation is not None:
            self.creation = creation
        if last_update is not None:
            self.last_update = last_update
        if master_archive_type is not None:
            self.master_archive_type = master_archive_type
        if res_id is not None:
            self.res_id = res_id
        if type_name is not None:
            self.type_name = type_name

    @property
    def links(self):
        """Gets the links of this ArchiveType.  # noqa: E501

        The _links_ list of the _archive-types_ resource  # noqa: E501

        :return: The links of this ArchiveType.  # noqa: E501
        :rtype: object
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ArchiveType.

        The _links_ list of the _archive-types_ resource  # noqa: E501

        :param links: The links of this ArchiveType.  # noqa: E501
        :type: object
        """

        self._links = links

    @property
    def creation(self):
        """Gets the creation of this ArchiveType.  # noqa: E501


        :return: The creation of this ArchiveType.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._creation

    @creation.setter
    def creation(self, creation):
        """Sets the creation of this ArchiveType.


        :param creation: The creation of this ArchiveType.  # noqa: E501
        :type: ChangeInfo
        """

        self._creation = creation

    @property
    def last_update(self):
        """Gets the last_update of this ArchiveType.  # noqa: E501


        :return: The last_update of this ArchiveType.  # noqa: E501
        :rtype: ChangeInfo
        """
        return self._last_update

    @last_update.setter
    def last_update(self, last_update):
        """Sets the last_update of this ArchiveType.


        :param last_update: The last_update of this ArchiveType.  # noqa: E501
        :type: ChangeInfo
        """

        self._last_update = last_update

    @property
    def master_archive_type(self):
        """Gets the master_archive_type of this ArchiveType.  # noqa: E501

        If the archive type is master type  # noqa: E501

        :return: The master_archive_type of this ArchiveType.  # noqa: E501
        :rtype: bool
        """
        return self._master_archive_type

    @master_archive_type.setter
    def master_archive_type(self, master_archive_type):
        """Sets the master_archive_type of this ArchiveType.

        If the archive type is master type  # noqa: E501

        :param master_archive_type: The master_archive_type of this ArchiveType.  # noqa: E501
        :type: bool
        """

        self._master_archive_type = master_archive_type

    @property
    def res_id(self):
        """Gets the res_id of this ArchiveType.  # noqa: E501

        The _archive-types_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :return: The res_id of this ArchiveType.  # noqa: E501
        :rtype: str
        """
        return self._res_id

    @res_id.setter
    def res_id(self, res_id):
        """Sets the res_id of this ArchiveType.

        The _archive-types_ resource identifier [https://en.wikipedia.org/wiki/Universally_unique_identifier[UUID]]  # noqa: E501

        :param res_id: The res_id of this ArchiveType.  # noqa: E501
        :type: str
        """

        self._res_id = res_id

    @property
    def type_name(self):
        """Gets the type_name of this ArchiveType.  # noqa: E501

        The name of the archive type  # noqa: E501

        :return: The type_name of this ArchiveType.  # noqa: E501
        :rtype: str
        """
        return self._type_name

    @type_name.setter
    def type_name(self, type_name):
        """Sets the type_name of this ArchiveType.

        The name of the archive type  # noqa: E501

        :param type_name: The type_name of this ArchiveType.  # noqa: E501
        :type: str
        """

        self._type_name = type_name

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ArchiveType):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ArchiveType):
            return True

        return self.to_dict() != other.to_dict()
